<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Update from Version 1.0.5 to 1.0.6</title>
</head>
<body>
<?php
/**

	Plazieren Sie diese Datei in das Hauptverzeichniss Ihrer Contrexx Installation
	und klicken Sie anschliessend auf "Update starten".

*/
if (!@include_once('config/configuration.php')) {
	print "Plazieren Sie diese Datei in das Hauptverzeichniss Ihrer Contrexx Installation.";
} else {
?>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post">
<?php

	$objUpdate = &new Update();
	if (!isset($_POST['doUpdate'])) {
		print "<input type=\"submit\" name=\"doUpdate\" value=\"Update ausfhren\" />";
		
	} else {
		require_once ASCMS_CORE_PATH.'/API.php';
		
		
		$errorMsg = '';
		$objDatabase = getDatabaseObject($errorMsg);
		
		$objUpdate->doUpdate();
	}
}


class Update
{
	var $updateFinished = false;
	var $errorMsg = "";
	var $dbPrefix = "contrexx_";
	var $oldPrefix;
	var $configFile = "/config/configuration.php";
	var $versionFile = "/config/version.php";
	var $sqlFile = "contrexx_opensource_update_1.0.5-1.0.6.sql";
	var $arrFiles;
	
	function Update() {
		$this->__constructor();
	}
	
	function __constructor() {
		$this->oldPrefix = DBPREFIX;
		
		$this->arrFiles = array(
			'/admin/backup' => array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777
			),
			'/feed'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777
			),
			'/media'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/images'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/themes'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/tmp'		=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			$this->configFile => array(
				'mode'		=> '0706',
				'mode_oct'	=> 0706
			),
			$this->versionFile => array(
				'mode'		=> '0706',
				'mode_oct'	=> 0706
			)
		);
	}
	
	function doUpdate() {
		
		$this->_checkPermissions();
		$this->_addPrintTemplate();
		$this->_addUserRestoreKey();
		$this->_updateGallery();
		$this->_updateDb();
		
		if (!empty($this->errorMsg)) {
			print "Updatevorgang war nicht erfolgreich!<br /><br />\n";
			print $this->errorMsg;
		} else {
			print "Updatevorgang wurde erfolgreich abgeschlossen.";
		}
	}
	
	function _addPrintTemplate()
	{
		global $objDatabase;
		$objDatabase->debug=true;
		$objResult = $objDatabase->Execute("INSERT INTO ".DBPREFIX."skins (`themesname`, `foldername`, `expert`) VALUES ('Druckansicht', 'print', 1)");
		if ($objResult !== false) {
			$skinId = $objDatabase->Insert_ID();
			
			$objDatabase->Execute("ALTER TABLE ".DBPREFIX."languages ADD `print_themes_id` TINYINT( 2 ) UNSIGNED DEFAULT '1' NOT NULL AFTER `themesid`");
			$objDatabase->Execute("UPDATE ".DBPREFIX."languages SET print_themes_id = ".$skinId);
		}
	}
	
	function _addUserRestoreKey()
	{
		global $objDatabase;
		
		$objResult = $objDatabase->MetaColumnNames(DBPREFIX."access_users");
		if (!in_array("restore_key", $objResult)) {
			$objDatabase->Execute("ALTER TABLE ".DBPREFIX."access_users ADD `restore_key` VARCHAR( 32 ) NOT NULL AFTER `groups`");
		} else {
			$objDatabase->Execute("ALTER TABLE ".DBPREFIX."access_users CHANGE `restore_key` `restore_key` VARCHAR( 32 ) NOT NULL");
		}
	}
	
	function _updateGallery()
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("CREATE TABLE `".DBPREFIX."module_gallery_language` (
		`gallery_id` INT UNSIGNED NOT NULL ,
		`lang_id` INT UNSIGNED NOT NULL ,
		`name` SET( 'name', 'desc' ) NOT NULL ,
		`value` TEXT NOT NULL ,
		PRIMARY KEY ( `gallery_id` , `lang_id` , `name` )
		)") !== false) {
			$objResult = $objDatabase->Execute('SELECT id FROM '.DBPREFIX.'languages');
			if ($objResult !== false) {
				$arrLanguages = array();
				while (!$objResult->EOF) {
					array_push($arrLanguages, $objResult->fields['id']);
					$objResult->MoveNext();
				}
		
				$objResult = $objDatabase->Execute('SELECT	id,
															name,
															description
													FROM	'.DBPREFIX.'module_gallery_categories
												');
				if ($objResult->RecordCount() > 0) {
					while (!$objResult->EOF) {
						foreach ($arrLanguages as $intLangId => $strValue) {
							$objDatabase->Execute('	INSERT
													INTO	'.DBPREFIX.'module_gallery_language
													SET		gallery_id='.$objResult->fields['id'].',
															lang_id='.$intLangId.',
															name="name",
															value="'.$objResult->fields['name'].'"
												');
							$objDatabase->Execute('	INSERT
													INTO	'.DBPREFIX.'module_gallery_language
													SET		gallery_id='.$objResult->fields['id'].',
															lang_id='.$intLangId.',
															name="desc",
															value="'.$objResult->fields['description'].'"
												');
						}
						$objResult->MoveNext();
					}
				}
				$objDatabase->Execute("ALTER TABLE `".DBPREFIX."module_gallery_categories` DROP `name`, DROP `description`");
				
				if ($objDatabase->Execute("CREATE TABLE `".DBPREFIX."module_gallery_language_pics` (
				`picture_id` INT UNSIGNED NOT NULL ,
				`lang_id` INT UNSIGNED NOT NULL ,
				`name` VARCHAR( 255 ) NOT NULL ,
				`desc` VARCHAR(255) NOT NULL,
				PRIMARY KEY ( `picture_id` , `lang_id` )
				)") !== false) {
					$objResult = $objDatabase->Execute('SELECT	id,
																name,
																linkname
														FROM	'.DBPREFIX.'module_gallery_pictures
													');
					if ($objResult->RecordCount() > 0) {
						while (!$objResult->EOF) {
							foreach ($arrLanguages as $intLangId => $strValue) {
								$objDatabase->Execute('	INSERT
														INTO	'.DBPREFIX.'module_gallery_language_pics
														SET		picture_id='.$objResult->fields['id'].',
																lang_id='.$intLangId.',
																name="'.$objResult->fields['name'].'",
																`desc`="'.$objResult->fields['linkname'].'"
													');
							}
							$objResult->MoveNext();
						}
					}
					
					$objDatabase->Execute("ALTER TABLE `".DBPREFIX."module_gallery_pictures` DROP `name`");
					$objDatabase->Execute("ALTER TABLE `".DBPREFIX."module_gallery_pictures` DROP `linkname`");
					
					return;
				}
			}
		}
		$this->errorMsg .= "Konnte die Gallery nicht aktualisieren!";
	}
	
	function _updateDb() {
		global $objDatabase;
		
		ini_set('auto_detect_line_endings',true);
		$fp = @fopen(dirname(__FILE__).'/'.$this->sqlFile,'r');
		if ($fp) {
			while (!feof($fp)) {
				$query = trim(fgets($fp));
				if (!$this->checkDbPrefix()) {
					$query = str_replace($this->dbPrefix, DBPREFIX, $query);
				}
				if ($objDatabase->Execute($query) === false) {
					$this->errorMsg .= "<b>Fehler bei ausfhrern der folgenden Datenbankabfrage:</b><br />\n";
					$this->errorMsg .= "<ul><li><i>".$query."</i></li>\n";
					$this->errorMsg .= "<li>Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i></li></ul><br /><br />\n";
				}
			}
			fclose($fp);
		} else {
			$this->errorMsg .= "Konnte die SQL-Updatedatei <b>".$this->sqlFile."</b> nicht ffnen!<br /><br />\n";
		}
	}
	
	function checkDbPrefix() {
		if ($this->oldPrefix == $this->dbPrefix) {
			return true;
		} else {
			return false;
		}
	}
	
	function _checkPermissions() {
		global $_PATHCONFIG;
		
		$statusMessage = "";
		$path = $_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'];
		
		foreach ($this->arrFiles as $file => $arrAttributes) {
			$arrAllFiles = array();
			$arrSubDirs = array();
			
			if (isset($arrAttributes['sub_dirs']) && $arrAttributes['sub_dirs']) {
				$arrSubDirs = $this->_getSubDirs($file);
				$arrAllFiles = array_merge(array($file), $arrSubDirs);
			} else {
				$arrAllFiles = array($file);
			}
			
			foreach ($arrAllFiles as $checkFile) {
				if (!is_writable($path.$checkFile)) {
					if ($this->isWindows()) {
						if (empty($statusMessage)) {
							$statusMessage = "Sie mssen den folgenden Dateien Schreibberechtigung zuweisen:<br />";
						}
						$statusMessage .= $path.$checkFile."<br />";
					} else {
						$result = $this->_chmod($checkFile, $arrAttributes);
						if ($result !== true) {
							$statusMessage .= $result;
						}
					}
				}
			}
		}
		if (!empty($statusMessage)) {
			$this->errorMsg .= $statusMessage;
		}
	}
	
	function _getSubDirs($directory) {
		global $_PATHCONFIG;
		
		$arrDirectories = array();
		
		$directoryPath = $_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'].$directory;
		
		$fp = @opendir($directoryPath);
		if ($fp) {
			while ($file = readdir($fp)) {
				$path = $directoryPath.DIRECTORY_SEPARATOR.$file;
				
				if ($file != "." && $file != "..") {
					array_push($arrDirectories, $directory.DIRECTORY_SEPARATOR.$file);
				
					if (is_dir(realpath($path))) {
						$arrDirectoriesRec = $this->_getSubDirs($directory.DIRECTORY_SEPARATOR.$file);
						if (count($arrDirectoriesRec)>0) {
							$arrDirectories = array_merge($arrDirectories, $arrDirectoriesRec);
						}
					}
				}
			}
			closedir($fp);
		}
		return $arrDirectories;
	}
	
	function isWindows() {
		if (substr(PHP_OS,0,3) == "WIN") {
			return true;
		} else {
			return false;
		}
	}
	
	function _chmod($file, $arrAttributes) {
		global $_FTPCONFIG, $_PATHCONFIG;
		
		if (!$this->isWindows() && $_FTPCONFIG['is_activated']) {
			// open ftp conneciton
			$objFtp = @ftp_connect($_FTPCONFIG['host'], $_FTPCONFIG['port'], 30);
			if ($objFtp) {
				// login to ftp server
				if (!@ftp_login($objFtp, $_FTPCONFIG['username'], $_FTPCONFIG['password'])) {
					@ftp_close($objFtp);
					return  "Die Authentifizierung mit dem angegebenen Benutzernamen und Passwort ist beim FTP-Server fehlgeschlagen!<br />";
				}
			} else {
				return "Kann keine Verbindung zum FTP-Server aufbauen!<br />";
			}
			
			if (phpversion()>=5) {
				// if system supports php5
				if (@ftp_chmod($objFtp, $arrAttributes['mode_oct'], $_FTPCONFIG['path'].$_PATHCONFIG['ascms_root_offset'].$file)) {
					return true;
				} else {
					return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
				}
			} else {
				// if system don't support php5 yet
				$chmodCmd = "CHMOD ".$arrAttributes['mode']." ".$_FTPCONFIG['path'].$_PATHCONFIG['ascms_root_offset'].$file;
				if (@ftp_site($objFtp, $chmodCmd)) {
					return true;
				} else {
					return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
				}
			}
		} else {
			if (@chmod($_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'].$file, $arrAttributes['mode_oct'])) {
				return true;
			} else {
				return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
			}
		}
	}
}
?>
</form>
</body>
</html>