<?php
/**
* Modul Calendar
*
* Outputs the Home calendar
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>   
* @module Calendar
* @modulegroup modules
* @access public
* @version 1.0.0 
**/

//error_reporting(E_ALL);
// require_once ASCMS_MODULE_PATH .'/calendar/lib/activecalendar.php';


class HomeCalendar
{ 	
    // {{{ properties

   /**
     * XML parser handle
     *
     * @var  array
     * @see  xml_parser_create()
     */
  

	/**
	* PHP5 Constructor
	*
	*/	
	function HomeCalendar() 
	{
	    $this->__construct();	
	}
	
	
	/**
	* Constructor
	*
	* Construct the Calendar functions
	*
	* @access	public
	*/		
    function __construct()
    {
	}   

	
	/**
	* Constructor
	*
	* Construct the Calendar functions
	*
	* @access	public
	* @param    string $pageContent
	* @param string
	*/
    function getHomeCalendar(){
    	/*
		$myurl=$_SERVER['PHP_SELF']; // the links url is this page
		$yearID=false; // init false to display current year
		$monthID=false; // init false to display current month
		$dayID=false; // init false to display current day
		extract($_GET); // get the new values (if any) of $yearID,$monthID,$dayID
		$cal = new activeCalendar($yearID,$monthID,$dayID);
		$cal->enableMonthNav($myurl);
		*/
    	
    	/*
		$cal = new activeCalendar("2007","11");
		$cal->setEvent("2007","11","17","event"); // it will create a class="event"
		$cal->setEvent("2007","11","7"); // it will also create a class="event" (default)
		//The following will create a class="event" and an <a href="index.php">
		$cal->setEvent("2007","11","20","event","index.php");
		//The following will create an event content 'test1'
		$cal->setEventContent("2007","11","12","T");
		//The following will create an event content 'test2' with an an <a href="index.php">
		$cal->setEventContent("2007","11","13","T","index.php");
		//The following will create an event content 'test3'
		//with an an <a href="index.php"> and class="event"
		$cal->setEventContent("2007","11","14","/","index.php","event");
		//The following will create a block of events (26th to 30th)
		for ($i=26;$i<=30;$i++) {
		    $cal->setEvent("2007","11",$i);
		}  	  	
		return $cal->showMonth();  
		*/ 
    }
    

    
	/**
	* Constructor
	*
	* Construct the Calendar functions
	*
	* @access	public
	* @param    string $pageContent
	* @param string
	*/
    function getHomeCalendarEvents(){
    	global $objDatabase, $_LANGID;
    	
        $return = "";
    	$today = date("Ymd");
    	// $today = "20040202"; // 20050405
        $limit = 20;
        // $objDatabase->debug = true;
	  	
		$query = "SELECT id, date, name, sort
		            FROM ".DBPREFIX."module_calendar
		           WHERE sort >= '".$today."'
		        ORDER BY id ASC
		           LIMIT ".$limit;
		
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				if(strlen($objResult->fields['name'])>$limit) {
				    $eventTitle = substr_replace($objResult->fields['name'],' ...', $limit);
				}
				$eventDate = substr($objResult->fields['date'], 3, 2).".".substr($objResult->fields['date'], 0, 2).".".substr($objResult->fields['date'], 6, 4);
				$return .= $eventDate." <a href=\"?section=calendar&amp;cmd=note&amp;id=".$objResult->fields['id']."\">".$eventTitle."</a><br />";
				$objResult->MoveNext();
			}
		}
		if(empty($return)){
			$return .= "Es wurden keine Termine gefunden...";	
		}
		return $return;	
    } 	
}
?>