<?php
/**
* Class community library
*
* provides common methodes for the community classes
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module community
* @modulegroups core_modules
* @access public
* @version 1.0.0
*/
class Community_Library
{
	/**
	* Configuration data
	*
	* @access public
	* @var array
	*/
	var $arrConfig = array();
	
	/**
	* Initialize the configuration variable
	*
	* @access public
	* @global object $objDatabase
	*/
	function initialize()
	{
		global $objDatabase;
		
		$objResult = $objDatabase->Execute("SELECT name, value, status FROM ".DBPREFIX."community_config");
		
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$this->arrConfig[$objResult->fields['name']] = array(
					'value'		=> $objResult->fields['value'],
					'status'	=> $objResult->fields['status']
				);
				$objResult->MoveNext();
			}
		}
	}
}
?>
